#include <iostream>
#include <string>
#include <algorithm>

using namespace std;

string division(int a, int b, int n)
{
    string res = "";
    int curr = a;

    for (int i = 0; i < n; i++)
    {
        curr *= 10;
        int new_digit = curr / b;
        res += new_digit + '0';
        curr -= b * new_digit;
    }

    return res;
}

const int MAX_N = 10000000;
int rem_first[MAX_N];

int count_period(int a, int b, int n)
{
    int curr = a;
    rem_first[curr] = 0;

    for (int i = 0; i < n; i++)
    {
        curr *= 10;
        int new_digit = curr / b;
        curr -= b * new_digit;
        if (rem_first[curr]) return i + 1 - rem_first[curr];
        rem_first[curr] = i + 1;
    }

    return n;
}

int main()
{
    int a, b, k, p;
    cin >> a >> b >> k >> p;

    a %= b;
    int c = count_period(a, b, MAX_N);
    k %= c;

    string res = division(a, b, k + p);
    cout << res.substr(k - 1, p);
}

