#include <iostream>
#include <vector>
using namespace std;
const long long MAXN = 3 * 1e7 + 1;
short dig[MAXN], digits[MAXN];
int main() {
    long long a, b, k, p;
    cin >> a >> b >> k >> p;
    vector<pair<long long, int> > primes;
    long long c = b;
    for (long long i = 2; c > 1; i++) {
        if (c % i == 0) {
            primes.push_back({i, 1});
            c /= i;
        }
        while (c % i == 0) {
            primes[primes.size() - 1].second *= i;
            c /= i;
        }
    }
    long long phi = 1;
    for (auto it : primes) {
        phi *= (it.first - 1) * it.second;
    }
    long long curr = 9;
    for (int i = 1; i <= phi; i++) {
        dig[i] = curr / b;
        curr -= dig[i] * b;
        curr *= 10;
        curr += 9;
    }
    long long cary = 0;
    for (int i = phi; i >= 1; i--) {
        cary += dig[i] * a;
        digits[i] = cary % 10;
        cary /= 10;
    }
    for (int i = 0; i < p; i++) {
        cout << digits[(k + i - 1) % phi + 1];
    }
    return 0;
}
