#include <bits/stdc++.h>

using namespace std;

string toString(int a)
{
    string res = "";

    while (a != 0)
    {
        res.push_back(char(a % 10 + '0'));
        a /= 10;
    }

    reverse(res.begin(), res.end());
    return res;
}

string fillUpWithZeors(const string& curr, int cnt)
{
    string res = curr;

    for (int i = 0; i < cnt; ++i)
    {
        res.push_back('0');
    }

    return res;
}

string divide(const string& a, long long b)
{
    long long carry = 0;
    string ans = "";

    for (int i = 0; i < a.size(); ++i)
    {
        carry = carry * 10 + (a[i] - '0');
        ans.push_back(char(carry / b + '0'));
        carry %= b;
    }

    string real = "";

    int idx = 0;

    while (ans[idx] == '0')
    {
        ++idx;
    }

    for (int i = idx; i < ans.size(); ++i)
    {
        real.push_back(ans[i]);
    }

    return real;
}

int main()
{
    int a, b, p;
    long long k;
    cin >> a >> b >> k >> p;

    string A = toString(a % b);
    A = fillUpWithZeors(A, k + p - 1);
    string ans = divide(A, b);

    for (int i = k - 1; i < k + p - 1; ++i)
    {
        cout << ans[i];
    }

    cout << endl;

    return 0;
}
