#include <iostream>
#include <vector>
#include <unordered_map>
#include <string>

using namespace std;
using ll = long long;
string frac(ll a, ll b, ll k, ll p) {
    vector<ll> decimalPart;
    unordered_map<ll, ll> remainders;
    ll remainder = a % b;
    while (remainder != 0 && remainders.find(remainder) == remainders.end()) {
        remainders[remainder] = decimalPart.size();
        remainder *= 10;
        decimalPart.push_back(remainder / b);
        remainder %= b;
    }

    if (remainder == 0) {
        decimalPart.resize(k + p, 0);
    } else {
        ll repeatStart = remainders[remainder];
        decimalPart.insert(decimalPart.begin() + repeatStart, decimalPart.begin() + repeatStart, decimalPart.end());
    }
    string result;
    for (ll i = k; i < k + p; ++i) {
        result += to_string(decimalPart[i]);
    }
    return result;
}

int main() {
    ll a = 1;
    ll b = 7;
    ll k = 2;
    ll p = 5;
    cin>>a>>b>>k>>p;
    k--;
    cout << frac(a, b, k, p) << endl;
    return 0;
}
