﻿#include <bits/stdc++.h>

#ifdef LOCAL
#include "debug.h"
#else
#define debug(x...) 228
#endif

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;

#define fi first
#define se second

const int inf = int(1e9) + 1;
const ll infll = ll(1e18) + 1;
const int mod = int(1e9) + 7;
mt19937_64 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());

template<typename T1, typename T2>
bool chmin(T1 &a, T2 b) {
    if (a > b) return a = b, true;
    return false;
}
template<typename T1, typename T2>
bool chmax(T1 &a, T2 b) {
    if (a < b) return a = b, true;
    return false;
}
void solve_case() {
    int a, b, p; cin >> a >> b;
    ll k; cin >> k >> p;
    int g = __gcd(a, b); a /= g, b /= g;
    int y = a;
    map<int, int> was;
    int start = -1, sz;
    vector<int> dig;
    for (int it = 0;; it++) {
        dig.push_back(((10 * y) / b) % 10);
        if (was.count(y)) {
            start = was[y];
            sz = it - start;
            debug(it);
            break;
        }
        was[y] = it;
        y = 10 * y % b;
    }
    k--;
    for (ll id = k; id < k + p; id++) {
        if (id < start) {
            cout << dig[id];
        } else {
            cout << dig[start + (id - start) % sz];
        }
    }
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(0), cout.tie(0);
#ifdef LOCAL
    freopen("inputik.txt", "r", stdin);
    clock_t tStart = clock();
#endif
    int T = 1;
    while (T--) {
        solve_case();
    }
#ifdef LOCAL
    fprintf(stderr, "\n>> Runtime: %.10fs\n", (double) (clock() - tStart) / CLOCKS_PER_SEC);
#endif
}
