#include <bits/stdc++.h>

#ifdef LOCAL
#include "debug.h"
#else
#define debug(x...) 228
#endif

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;

#define fi first
#define se second

const int inf = int(1e9) + 1;
const ll infll = ll(1e18) + 1;
const int mod = int(1e9) + 7;
mt19937_64 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());

template<typename T1, typename T2>
bool chmin(T1 &a, T2 b) {
    if (a > b) return a = b, true;
    return false;
}
template<typename T1, typename T2>
bool chmax(T1 &a, T2 b) {
    if (a < b) return a = b, true;
    return false;
}
void solve_case() {
    int a, b; cin >> a >> b;
    ll k, p; cin >> k >> p;
    int g = __gcd(a, b); a /= g, b /= g;
    int y = a;
    int phi = 0;
    for (int i = 1; i < b; i++) {
        if (__gcd(i, b) == 1) {
            phi++;
        }
    }
    int b2 = 0;
    int ob = b;
    int b5 = 0;
    while (ob % 2 == 0) {
        ob /= 2;
        b2++;
    }
    while (ob % 5 == 0) {
        ob /= 5;
        b5++;
    }
    // first max(b2, b5) digits
    map<int, int> was;
    int start = max(b2, b5), sz;
    vector<int> dig;
    for (int it = 0; it < max(b2, b5); it++) {
        dig.push_back(((10 * y) / b) % 10);
        was[y] = it;
        y = 10 * y % b;
    }
    // 10^p mod b = 10 ^ (p mod (phi(b) - 1))
    k--;
    p += k - 1;
    while (k < p && k < start) {
        cout << dig[k];
        k++;
    }
    phi = max(phi, 2);
    if (k <= p) {
        ll len = p - k;
        k -= start;
        k %= phi - 1;
        p = k + len;
        for (int it = 0; k < p; it++) {
            if (it == k) {
                cout << ((10 * y) / b) % 10;
                k++;
            }
            y = 10 * y % b;
        }
    }
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(0), cout.tie(0);
#ifdef LOCAL
    freopen("inputik.txt", "r", stdin);
    clock_t tStart = clock();
#endif
    int T = 1;
    while (T--) {
        solve_case();
    }
#ifdef LOCAL
    fprintf(stderr, "\n>> Runtime: %.10fs\n", (double) (clock() - tStart) / CLOCKS_PER_SEC);
#endif
}
