#pragma GCC optimize("O3,unroll-loops")

#include <bits/stdc++.h>

using namespace std;

#define int long long

using pii = pair<int, int>;

void print(int d, int a, int r, int b, int p) {
    cout << d;
    p--;
    int rem = r;
    for (int i = 0; i < p; i++) {
        if (!a) {
            cout << 0;
            continue;
        }

        int zeros = -1;
        while (a < b) {
            a *= 10;
            zeros++;
        }
        rem += max(0ll, zeros);

        if (rem > 0) {
            rem--;
            cout << 0;
        } else {
            cout << a / b;
            a %= b;
        }
    }
}

void solve() {
    int a, b, k, p;
    cin >> a >> b >> k >> p;
    k--;

    const int D = 3000;
    vector<pair<pii, int>> digits;
    for (int i = 0; i < D; i++) {
        if (!a) {
            digits.push_back({{0, 0}, 0});
            continue;
        }

        int zeros = -1;
        while (a < b) {
            a *= 10;
            zeros++;
            if (zeros > 0) {
                digits.push_back({{0, a}, (a < b)});
            }
        }
        digits.push_back({{a / b, a % b}, 0});
        a %= b;
    }
    digits.resize(D);

    if (k < D) {
        print(digits[k].first.first, digits[k].first.second, digits[k].second, b, p);
        return;
    }

    int S = -1;
    int P = -1;
    for (int st = 0; st < 1200; st++) {
        if (S != -1 && P != -1) break;
        for (int per = 1; per < 1200; per++) {
            bool ok = true;
            for (int pos = st; pos < D; pos += per) {
                for (int i = 0; i < per; i++) {
                    if (pos + i < D && digits[st + i].first.first != digits[pos + i].first.first) {
                        ok = false;
                        break;
                    }
                }
            }
            if (ok) {
                S = st;
                P = per;
                break;
            }
        }
    }
    assert(S != -1 && P != -1);


    k -= S;
    k %= P;
    print(digits[k].first.first, digits[k].first.second, digits[k].second, b, p);
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    solve();

    return 0;
}
