// frac.cpp : This file contains the 'main' function. Program execution begins and ends there.
//

#include <iostream>
using namespace std;
#define ll long long
#include <vector>
#define vi vector<int>
ll gcd(ll a, ll b) {
    if (b > a)swap(a, b);
    if (b == 0)return a;
    return gcd(a%b, b);
}
int inv[] = {0,1,0,7,0,0,0,3,0,9};

ll po(ll a, ll b, ll mod) {
    if (b == 0)return 1;
    ll ans = po(a, b / 2, mod);
    ans = (ans * ans) % mod;
    if (b % 2)ans = (ans * a) % mod;
    return ans;
}
int phi(int b) {
    ll ans = b;
    vi p;
    int it = 2;
    while (it < 1e4) {
        if ((b % it) == 0) {
            p.push_back(it);
            while ((b % it) == 0) {
                b /= it;
            }
        }
        it++;
    }
    if (b > 1)p.push_back(b);
    for (int pr : p) {
        ans /= pr;
        ans *= (pr - 1);
    }
    return ans;
}
int dig(ll a, ll b, ll k) {
    for (int i = 0; k > 0 && i < 10; i++) {
        a *= 10;
        k--;
    }
    ll g = gcd(a, b);
    a /= g, b /= g;
    if (k == 0) {
        return (a / b) % 10;
    }
    else {
        int t = inv[b % 10];
        ll ph = phi(b);
        ll p = po(10, k, b);
        //p = po(p, ph - 1, b);
        a %= b;
        ll res = (p * a) % b;
        res = t * res;
        res %= 10;
        res = 10 - res;
        if (res == 10)res = 0;
        return res;
    }
}
int main()
{
    ll a, b, k, p;
    cin >> a >> b >> k >> p;
    for (ll i = k; i < k + p; i++)cout << dig(a, b, i);
}

// Run program: Ctrl + F5 or Debug > Start Without Debugging menu
// Debug program: F5 or Debug > Start Debugging menu

// Tips for Getting Started: 
//   1. Use the Solution Explorer window to add/manage files
//   2. Use the Team Explorer window to connect to source control
//   3. Use the Output window to see build output and other messages
//   4. Use the Error List window to view errors
//   5. Go to Project > Add New Item to create new code files, or Project > Add Existing Item to add existing code files to the project
//   6. In the future, to open this project again, go to File > Open > Project and select the .sln file
