#include <bits/stdc++.h>

using namespace std;

typedef __int128 ll;
typedef vector<ll> v;
typedef vector<v> vv;
typedef vector<vv> vvv;
typedef pair<ll,ll> p;
typedef vector<p> vp;
typedef vector<vp> vvp;
typedef vector<vvp> vvvp;
typedef pair<ll, p> tri;
typedef vector<tri> vtri;
typedef vector<vtri> vvtri;
typedef vector<vvtri> vvvtri;
typedef vector<bool> vb;
typedef vector<vb> vvb;
typedef vector<vvb> vvvb;

#define f first
#define s second
#define pb push_back
#define eb emplace_back
#define all(v) (v).begin(),(v).end()

const ll INF = 1e18;
const ll mod = 1e9 + 7;

ll pow(ll a, ll b)
{
    if (b == 0) return 1;
    ll res = pow(a, b / 2);
    if (b % 2 == 1) res *= a;
    return res;
}

int main()
{
    ios_base::sync_with_stdio(false); cin.tie(NULL); cout.tie(NULL);
    int aa, ba, ka, pa;
    cin >> aa >> ba >> ka >> pa;
    ll a = aa, b = ba, k = ka, p = pa;
    ll cpy = b;
    while (cpy % 5 == 0) cpy /= 5;
    while (cpy % 2 == 0) cpy /= 2;
    if (cpy == 1)
    {
        //finite representation
        ll chunk = 5;
        ll i = 0;
        while (true)
        {
            ll otherDigits = (a * (ll)pow(10, i + chunk) / b) % (ll)pow(10, chunk);
            if (otherDigits == 0) break;
            else i++;
        }
        ll seq = (a * pow(10, i)) / b;
        string digsStr = "";
        while (seq > 0)
        {
            digsStr += '0' + (seq % 10);
            seq /= 10;
        }
        reverse(all(digsStr));
        string res = "";
        for (ll i=  0; i < p; i++) res += '0';
        for (ll i = 0; (i + k - 1) < digsStr.size(); i++) res[i] = digsStr[i + k - 1];
        cout << res << "\n";
        return 0;
    }
    ll cycle = -1;
    ll i = 1;
    ll seq;
    while (true)
    {
        ll digits = a * pow(10, i) / b;
        ll otherDigits = (a * (ll)pow(10, 2 * i) / b) % (ll)pow(10, i);
        if (digits == otherDigits)
        {
            cycle = i; seq = digits; break;
        }
        else i++;
    }
    string digsStr = "";
    while (seq > 0)
    {
        digsStr += '0' + (seq % 10);
        seq /= 10;
    }
    reverse(all(digsStr));
    ll start = (k - 1 + cycle) % cycle;
    for (ll i=  0; i < p; i++)
    {
        cout << digsStr[start]; 
        start = (start + 1) % cycle;
    }
    cout << "\n";
    return 0;
}