#include <iostream>
#include <vector>
using namespace std;
const long long MAXN = 3 * 1e7 + 1;
short dig[MAXN], digits[MAXN];
long long power(long long a, long long b) {
    if (b == 0) {
        return 1;
    }
    if (b % 2 == 0) {
        return power(a * a, b / 2);
    } else {
        return a * power(a * a, b / 2);
    }
}
int main() {
    long long a, b, k, p;
    cin >> a >> b >> k >> p;
    vector<pair<long long, int> > primes;
    long long c = b;
    for (long long i = 2; i * i <= c; i++) {
        if (c % i == 0) {
            primes.push_back({i, 1});
            c /= i;
        }
        while (c % i == 0) {
            primes[primes.size() - 1].second++;
            c /= i;
        }
    }
    if (c != 1) {
        primes.push_back({c, 1});
        c /= c;
    }
    long long phi = 1;
    for (auto it : primes) {
        phi *= (it.first - 1) * power(it.first, it.second - 1);
    }
    long long curr = 9;
    for (int i = 1; i <= phi; i++) {
        dig[i] = curr / b;
        curr -= dig[i] * b;
        curr *= 10;
        curr += 9;
    }
    long long cary = 0;
    for (int i = phi; i >= 1; i--) {
        cary += dig[i] * a;
        digits[i] = cary % 10;
        cary /= 10;
    }
    for (int i = 0; i < p; i++) {
        cout << digits[(k + i - 1) % phi + 1];
    }
    return 0;
}
