#include <iostream>
#include <vector>

#define endl '\n'

using namespace std;

const int64_t BASE = 31;

const int64_t LIMIT = 5000;

int main() {
    int64_t a, b, k, p;
    cin >> a >> b >> k >> p;

    a *= 10ll;

    vector<int64_t> pow;
    vector<int64_t> digits;

    string result = "";

    for (int64_t i = 0; i < min(k + p - 1, LIMIT) and a != 0ll; ++i) {
        int64_t currentDigit = a / b;

        if (i >= k - 1) {
            result += (currentDigit + '0');
        }

        digits.push_back(currentDigit);

        a %= b;
        a *= 10ll;
    }

    if (a == 0) {
        while ((int64_t) result.size() < p) {
            result += "0";
        }
    } else if ((int64_t) digits.size() == LIMIT) {
        int64_t targetPos = -1, targetLength = -1;

        for (int64_t periodStart = 0; periodStart < LIMIT; ++periodStart) {
            int64_t periodLength = LIMIT - periodStart + 1ll;

            if (periodLength % 2ll == 1ll) {
                continue;
            }

            periodLength /= 2ll;

            int64_t i = periodStart;
            int64_t j = periodStart + periodLength;

            while (j < LIMIT and digits[i] == digits[j]) {
                ++i;
                ++j;
            }

            bool everythingEqual = j == LIMIT;

            if (everythingEqual) {
                targetPos = periodStart;
                targetLength = periodLength;

                break;
            }
        }

        k -= targetPos;

        int64_t startPositionInPeriod = targetPos + (k % targetLength);

        for (int64_t i = startPositionInPeriod; (int) result.size() < p; ++i) {
            result += (digits[i] + '0');
        }
    }

    cout << result << endl;

    return 0;
}
