#include <algorithm>
#include <iostream>
#include <numeric>
#include <cassert>
#include <vector>
#include <bitset>

typedef long long llong;
const int MAXN = 30000000 + 10;
const int INF  = 1e9;

int a, b, p, k;
std::bitset <MAXN> was;
void solve()
{
    if (k <= 3e7)
    {
        for (int i = 1 ; i < k ; ++i)
        {
            a *= 10;
            a %= b;
        }

        for (int i = 1 ; i <= p ; ++i)
        {
            a *= 10;
            std::cout << a / b;
            a %= b;
        }

        return;
    }

    int originalA = a;
    for (int i = 1 ; i < k ; ++i)
    {
        a *= 10;
        if (was[a % b])
        {
            int pos = 0;
            while (true)
            {
                pos++;
                originalA *= 10;
                if (originalA % b == a % b)
                {
                    break;
                }

                originalA %= b;
            }

            int num = a;
            k -= pos - 1;
            k %= i - pos;
            for (int j = 1 ; j <= p ; ++j)
            {
                std::cout << num;
                num %= b;
                num *= 10;
            }
        
            break;
        }

        was[a % b] = 1;
        a %= b;
    }
}

void input()
{
    std::cin >> a >> b >> k >> p;
}   

void fastIOI()
{
    std::ios_base :: sync_with_stdio(0);
    std::cout.tie(NULL);
    std::cin.tie(NULL);
}

int main()
{
    fastIOI();
    input();
    solve();

    return 0;
}