#include <iostream>
#include <vector>
#include <unordered_map>
#include <string>

using namespace std;

string frac(int a, int b, int k, int p) {
    vector<int> decimalPart;
    unordered_map<int, int> remainders;
    int remainder = a % b;
    while (remainder != 0 && remainders.find(remainder) == remainders.end()) {
        remainders[remainder] = decimalPart.size();
        remainder *= 10;
        decimalPart.push_back(remainder / b);
        remainder %= b;
    }

    if (remainder == 0) {
        decimalPart.resize(k + p, 0);
    } else {
        int repeatStart = remainders[remainder];
        decimalPart.insert(decimalPart.begin() + repeatStart, decimalPart.begin() + repeatStart, decimalPart.end());
    }
    string result;
    for (int i = k; i < k + p; ++i) {
        result += std::to_string(decimalPart[i]);
    }
    return result;
}

int main() {
    int a = 1;
    int b = 7;
    int k = 2;
    int p = 5;
    cin>>a>>b>>k>>p;
    k--;
    cout << frac(a, b, k, p) << endl;
    return 0;
}
