#include <bits/stdc++.h>

using namespace std;

#define int long long

using pii = pair<int, int>;

int a, b, k, p, rem;

void print() {
    for (int i = 1; i < k + p; i++) {
        int d = 0;
        if (a) {
            int zeros = -1;
            while (a < b) {
                a *= 10;
                zeros++;
            }
            rem += max(0ll, zeros);

            if (rem > 0) {
                rem--;
                d = 0;
            } else {
                d = a / b;
                a %= b;
            }
        }

        if (i >= k) {
            cout << d;
        }
    }
}

void solve() {
    cin >> a >> b >> k >> p;

    const int D = 1500;
    vector<int> digits;
    int ta = a;
    rem = 0;
    for (int i = 0; i < D; i++) {
        if (!ta) {
            digits.push_back(0);
            continue;
        }

        int zeros = -1;
        while (ta < b) {
            ta *= 10;
            zeros++;
        }
        rem += max(0ll, zeros);

        if (rem > 0) {
            digits.push_back(0);
        } else {
            digits.push_back(ta / b);
            ta %= b;
        }
    }

    if (k <= D) {
        print();
        return;
    }

    int S = -1;
    int P = -1;
    for (int st = 0; st < 500; st++) {
        if (S != -1 && P != -1) break;
        for (int per = 1; per < 300; per++) {
            bool ok = true;
            for (int pos = st; pos < D; pos += per) {
                for (int i = 0; i < per; i++) {
                    if (pos + i < D && digits[st + i] != digits[pos + i]) {
                        ok = false;
                        break;
                    }
                }
            }
            if (ok) {
                S = st;
                P = per;
                break;
            }
        }
    }
    assert(S != -1 && P != -1);


    k -= S;
    rem = 0;
    for (int i = 0; i < S; i++) {
        if (a) {
            int zeros = -1;
            while (a < b) {
                a *= 10;
                zeros++;
            }
            rem += max(0ll, zeros);

            if (!rem) {
                a %= b;
            }
        }
    }
    k %= P;
    k++;
    print();
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    solve();

    return 0;
}
