#include <bits/stdc++.h>

#define ll long long
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define watch(x) cerr << (#x) << " : " << x << '\n'
#define boost ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);

using namespace std;

ll phi(ll n) {
    ll res = n;
    for (int i = 2; i * i <= n; i++)
        if (n % i == 0) {
            while (n % i == 0)
                n /= i;
            res -= res / i;
        }
    if (n > 1)
        res -= res / n;
    return res;
}

void solve() {
    ll a, b, k, p;
    cin >> a >> b >> k >> p;

    ll cycle_len = phi(b);

    vector <short> period;
    for (int c = 0; c < 2 * cycle_len; c++) {
        a *= 10;
        ll x = a / b;
        a -= x * b;
        period.push_back(x % 10);
    }

    vector <short> real_cycle;
    for (int x = 0; x < cycle_len; x++) {
        real_cycle.push_back(period.back());
        period.pop_back();
    }

    while ((int)period.size() >= cycle_len) {
        bool can = true;
        for (int x = 0; x < cycle_len; x++)
            if (period[(int)period.size() - x - 1] != real_cycle[x])
                can = false;
        if (!can)
            break;
        for (int x = 0; x < cycle_len; x++)
            period.pop_back();
    }

    reverse(all(real_cycle));

    auto find_kth = [&](ll p) -> short {
        p--;
        if (p < (int)period.size())
            return period[p];
        p -= (int)period.size();
        return real_cycle[p % (int)real_cycle.size()];
    };

    for (ll x = k; x < k+p; x++)
        cout << find_kth(x);
}

main() {
    boost;
    solve();
    return 0;
}
