#include <bits/stdc++.h>

#define ll long long
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define watch(x) cerr << (#x) << " : " << x << '\n'
#define boost ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);

using namespace std;

int phi(int n) {
    int res = n;
    for (int i = 2; i * i <= n; i++)
        if (n % i == 0) {
            while (n % i == 0)
                n /= i;
            res -= res / i;
        }
    if (n > 1)
        res -= res / n;
    return res;
}

const int N = 16'000'000;
char period[N], real_cycle[N];
int pt_period = 0, pt_cycle = 0;

void solve() {
    int a, b, haha;
    ll k;
    cin >> a >> b >> k >> haha;

    ll cycle_len = phi(b);

    for (int c = 0; c < N; c++) {
        a *= 10;
        ll x = a / b;
        a -= x * b;
        period[pt_period++] = x % 10;
    }

    for (int x = 0; x < cycle_len; x++)
        real_cycle[pt_cycle++] = period[--pt_period];

    while (pt_period >= cycle_len) {
        bool can = true;
        for (int x = 0; x < cycle_len; x++)
            if (period[pt_period - x - 1] != real_cycle[x])
                can = false;
        if (!can)
            break;
        pt_period -= cycle_len;
    }

//    reverse(real_cycle, real_cycle + pt_cycle);

    for (ll x = k; x < k+haha; x++) {
        int p = x;
        p--;
        if (p < pt_period)
            cout << (short)period[p];
        else {
            p -= pt_period;
            p %= pt_cycle;
            p = (pt_cycle - p - 1);
            cout << (short)real_cycle[p];
        }
    }
}

main() {
    boost;
    solve();
    return 0;
}
